#include <sourcemod>
#include <sdktools>

#define VERSION "1.2a" 

#define SUPERMAN_MDL "models/player/baronettes/superman.mdl"

#define ROCK_MDL "models/weapons/kryptonite.mdl"

#define WEAPONNUM 2

#define TEAM_ALLIES 2
#define TEAM_AXIS 3

#define MOVETYPE_WALK 2
#define MOVETYPE_FLYGRAVITY 5
#define MOVECOLLIDE_DEFAULT 0
#define MOVECOLLIDE_FLY_BOUNCE 1

#define AMP_SHAKE        50.0
#define DUR_SHAKE        1.0

#define COLOR_DEFAULT 0x01
#define COLOR_GREEN 0x04

#define TRAIL_MDL "materials/sprites/lgtning.vmt"
#define TRAIL_COLOR {255, 25, 25, 75}
#define ROCK_COLOR {0, 255, 80, 50}
#define ADD_OUTPUT "OnUser1 !self:Kill::1.7:1"

new redColor[4] = {255, 25, 25, 150};

new g_BeamSprite;
new g_TrailSuperman;

new PropMoveCollide;
new PropMoveType;
new PropVelocity;
new Handle:FlySpeed;
new Handle:MaxSpeed;
new bool:Flying[MAXPLAYERS+1];
new bool:Eligible[MAXPLAYERS+1];
new bool:elig;

new Handle:g_CvarLife = INVALID_HANDLE;
new Handle:g_CvarWidth = INVALID_HANDLE;
new Handle:g_Cvar_SupermanHealth = INVALID_HANDLE;
new Handle:g_Cvar_SupermanSpawnEffect = INVALID_HANDLE;

new	superman = 0;

new String:Weapon[WEAPONNUM][] = {"","weapon_amerknife"};


new const Float:g_fSpin[3] = {1877.4, 0.0, 0.0};
new Handle:g_CVarVelocity;
new Float:g_fVelocity;

new Handle:bonusround_damage ;
new Handle:bonusround_radius ;
new Handle:bonusround_pushforce ;


public Plugin:myinfo =
{
	name = "Dod Superman Bounusround",
	author = "Andi67",
	description = "Special Bonusround for Dods",
	version = VERSION,
	url = "www.dodsourceplugins.net"
};

public OnPluginStart()
{
	CreateConVar("dod_superman_bonusround", VERSION, "Version", FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	g_CvarLife = CreateConVar("dod_superman_bonusround_beamlife", "0.1", "Life of the Beam");
	g_CvarWidth = CreateConVar("dod_superman_bonusround_beamwidth", "0.1", "Width of the Beam");
	g_Cvar_SupermanHealth = CreateConVar("dod_superman_bonusround_hp", "500", "Sets Supermans Health", FCVAR_PLUGIN);
	g_Cvar_SupermanSpawnEffect = CreateConVar("dod_superman_bonusround_spawneffect", "1", "Enables Superman Spawneffect.");
	
	g_CVarVelocity = CreateConVar("dod_superman_kryptonite_velocity", "5", "Velocity (speed) for throwing kryptonite.", _, true, 1.0, true, 10.0);
	
	g_fVelocity = (1000.0 + (250.0 * GetConVarFloat(g_CVarVelocity)));
	HookConVarChange(g_CVarVelocity, CVarChange);
	
	FlySpeed = CreateConVar("dod_superman_bonusround_flight_speed", "50", "Flying speed.",FCVAR_PLUGIN);
	MaxSpeed = CreateConVar("dod_superman_bonusround_flight_max_speed", "500", "Flying max speed.", FCVAR_PLUGIN);
	
	bonusround_damage = CreateConVar("dod_superman_bonusround_damage", "50", "amount of damage", FCVAR_PLUGIN);
	bonusround_radius = CreateConVar("dod_superman_bonusround_radius", "200", " radius of start", FCVAR_PLUGIN);	
	bonusround_pushforce = CreateConVar("dod_superman_bonusround_pushforce", "600", "pushforce that is done", FCVAR_PLUGIN);
	
	PropMoveCollide = FindSendPropOffs("CBaseEntity","movecollide");
	PropMoveType    = FindSendPropOffs("CBaseEntity","movetype");
	PropVelocity    = FindSendPropOffs("CBasePlayer","m_vecVelocity[0]");	
	
	HookEvent("dod_stats_weapon_attack", Event_DodStatsWeaponAttack);
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("player_spawn", Event_PlayerSpawn);
}

public CVarChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
{
	if (convar == g_CVarVelocity)
		g_fVelocity = (1000.0 + (250.0 * StringToFloat(newValue)));	
}

public OnMapStart()
{
	g_BeamSprite = PrecacheModel("materials/sprites/laser.vmt");
	PrecacheModel("materials/sprites/physbeam.vmt");	
	g_TrailSuperman = PrecacheModel(TRAIL_MDL , true);
	
	AddFileToDownloadsTable("models/player/baronettes/superman.dx80.vtx");
	AddFileToDownloadsTable("models/player/baronettes/superman.dx90.vtx");
	AddFileToDownloadsTable("models/player/baronettes/superman.mdl");
	AddFileToDownloadsTable("models/player/baronettes/superman.phy");
	AddFileToDownloadsTable("models/player/baronettes/superman.sw.vtx");
	AddFileToDownloadsTable("models/player/baronettes/superman.vvd");
	AddFileToDownloadsTable("materials/models/player/baronettes/superman_suit.vmt");
	AddFileToDownloadsTable("materials/models/player/baronettes/superman_suit.vtf");
	AddFileToDownloadsTable("materials/models/player/baronettes/superman_suit_n.vtf");
	
	AddFileToDownloadsTable("models/weapons/kryptonite.dx80.vtx");
	AddFileToDownloadsTable("models/weapons/kryptonite.dx90.vtx");
	AddFileToDownloadsTable("models/weapons/kryptonite.mdl");
	AddFileToDownloadsTable("models/weapons/kryptonite.phy");
	AddFileToDownloadsTable("models/weapons/kryptonite.sw.vtx");
	AddFileToDownloadsTable("models/weapons/kryptonite.vvd");
	AddFileToDownloadsTable("materials/models/weapons/w_models/kryptonite/kryptonite.vmt");
	AddFileToDownloadsTable("materials/models/weapons/w_models/kryptonite/kryptonite.vtf");	
	
	PrecacheModel(SUPERMAN_MDL , true);
	PrecacheModel(ROCK_MDL , true);
	
	AddFileToDownloadsTable("sound/countdown/countdown.mp3");
	PrecacheSound("countdown/countdown.mp3", true);	
	
	superman = 0;
	
	new time;
	GetMapTimeLeft(time);
	CreateTimer(float(time) - 120.0, EnableBonusround, INVALID_HANDLE, TIMER_FLAG_NO_MAPCHANGE);
	CreateTimer(float(time) -131, Countdown, INVALID_HANDLE, TIMER_FLAG_NO_MAPCHANGE);
}

public OnMapTimeLeftChanged()
{
	new time;
	GetMapTimeLeft(time);
	CreateTimer(float(time) - 120.0, EnableBonusround, INVALID_HANDLE, TIMER_FLAG_NO_MAPCHANGE);
	

	CreateTimer(float(time) -131, Countdown, INVALID_HANDLE, TIMER_FLAG_NO_MAPCHANGE);
}

public Action:Countdown(Handle:timer)
{
	EmitSoundToAll("countdown/countdown.mp3");
}

public Action:EnableBonusround(Handle:timer)
{
	StartSupermanBonusround();
	PrintHintTextToAll("Superman Bonusround is active!!!");
	
	for(new i=1; i<=MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i))
		{
			RemoveWeapons(i);
			GiveWeapons(i);
		}
	}
}

StartSupermanBonusround()
{		
	new iClients[MaxClients+1];
	new iNumClients;
	
	for(new i=1; i<=MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i))
		{
			iClients[iNumClients++] = i;
		}
	}
	
	superman = iClients[GetRandomInt(1 , iNumClients)-1];
	
	superman = 1;
	
	if(IsClientConnected(superman) && IsPlayerAlive(superman) && IsValidEntity(superman))	
	{
		PrintToChat(superman,"%c[Bonusround] %c Message: [%cYou are now Superman%c] Press the , [%cAttack-Button%c] to ignite the Enemys!!!",COLOR_GREEN,COLOR_DEFAULT,COLOR_GREEN,COLOR_DEFAULT,COLOR_GREEN,COLOR_DEFAULT);
		SetEntityHealth(superman, GetConVarInt(g_Cvar_SupermanHealth))
		SetEntityModel(superman , SUPERMAN_MDL);
		
		TE_SetupBeamFollow(superman, g_TrailSuperman, 0, 0.7, 7.7, 7.7, 3, TRAIL_COLOR);
		TE_SendToAll();
		
		new String:SzName[64];
		GetClientName(superman, SzName, sizeof(SzName));
			
		PrintHintTextToAll("Superman is now: %s.", SzName);		
		
		if(GetConVarInt(g_Cvar_SupermanSpawnEffect) == 1)
		{
			CreateSpawnEffect(superman);
		}
	}
}

RemoveWeapons(client)
{
	for(new i = 0; i < 4; i++)
	{
		new weapon = GetPlayerWeaponSlot(client, i);
		if(weapon != -1)
		{
			RemovePlayerItem(client, weapon);
			RemoveEdict(weapon);
		}
	}
}

GiveWeapons(client)
{
	GivePlayerItem(client, Weapon[1]);
	
	new weaponent = GetPlayerWeaponSlot(client, 2);
	
	SetEntityRenderMode(weaponent,  RENDER_TRANSCOLOR);
	SetEntityRenderColor(weaponent, 0, 0, 0, 0);
}

public Action:CreateSpawnEffect(any:client)
{
	new tesla = CreateEntityByName("point_tesla"); 
	decl String:sz_teslaname[32]; 
	Format(sz_teslaname, sizeof(sz_teslaname), "laser_%i", tesla);
	DispatchKeyValue(tesla, "targetname", sz_teslaname);
  
	DispatchKeyValue(tesla, "parentname", sz_teslaname);
	DispatchKeyValue(tesla, "m_flRadius", "200.0"); 
	DispatchKeyValue(tesla, "m_SoundName", "DoSpark"); 
	DispatchKeyValue(tesla, "beamcount_min", "4"); 
	DispatchKeyValue(tesla, "beamcount_max", "6"); 
	DispatchKeyValue(tesla, "texture", "sprites/physbeam.vmt");
	DispatchKeyValue(tesla, "m_Color", "255 255 255"); 
	DispatchKeyValue(tesla, "thick_min", "10.0");
	DispatchKeyValue(tesla, "thick_max", "11.0");
	DispatchKeyValue(tesla, "lifetime_min", "0.3");
	DispatchKeyValue(tesla, "lifetime_max", "0.3"); 
	DispatchKeyValue(tesla, "interval_min", "0.1"); 
	DispatchKeyValue(tesla, "interval_max", "0.2"); 
	DispatchSpawn(tesla); 
	SetEntityRenderColor(tesla,200,0,0,255);
	AcceptEntityInput(tesla, "TurnOn"); 
	AcceptEntityInput(tesla, "DoSpark");

	new Float:location[3];
	GetClientAbsOrigin(client,location);
	location[0] -= 0;
	location[1] -= 0;
	location[2] += 90;
 
	ActivateEntity(tesla); 
	AcceptEntityInput(tesla, "TurnOn"); 
	TeleportEntity(tesla,location,NULL_VECTOR,NULL_VECTOR); 
	SetVariantString("!activator");
	AcceptEntityInput(tesla, "SetParent", client, tesla, 0);
	AcceptEntityInput(tesla, "SetParentAttachmentMaintainOffset", client, client, 0);
	
	CreateTimer(2.0, RemoveSpawnEffect, tesla);
}

public Action:RemoveSpawnEffect(Handle:timer, any:entity)
{
	if (IsValidEntity(entity))
	{
		AcceptEntityInput(entity, "kill");
		RemoveEdict(entity);
	}
}

public Event_PlayerSpawn(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client;
	client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	new time;
	if (GetMapTimeLeft(time) && time > 0)
	{
		new startTime = 120;
		if (time - startTime < 0 )
		{
	
			if(client != superman)
			{
				RemoveWeapons(client);
				GiveWeapons(client);
			}
		}
	}
}

public Event_PlayerDeath(Handle:event,const String:name[],bool:dontBroadcast)
{
	new victim;
	victim = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if(victim == superman)
	{
		new iClients[MaxClients+1];
		new iNumClients;
	
		for(new i=1; i<=MaxClients; i++)
		{
			if(IsClientInGame(i) && IsPlayerAlive(i))
			{
				iClients[iNumClients++] = i;
			}
		}
		
		superman = iClients[GetRandomInt(1 , iNumClients)-1];	
		
		if(IsClientConnected(superman) && IsPlayerAlive(superman) && IsValidEntity(superman))	
		{
			PrintToChat(superman,"%c[Bonusround] %c Message: [%cYou are now Superman%c] Press the , [%cAttack-Button%c] to ignite the Enemys!!!",COLOR_GREEN,COLOR_DEFAULT,COLOR_GREEN,COLOR_DEFAULT,COLOR_GREEN,COLOR_DEFAULT);	
			SetEntityHealth(superman, GetConVarInt(g_Cvar_SupermanHealth))
			SetEntityModel(superman , SUPERMAN_MDL);
		
			TE_SetupBeamFollow(superman, g_TrailSuperman, 0, 0.7, 7.7, 7.7, 3, TRAIL_COLOR);
			TE_SendToAll();
		
			new String:SpName[64];
			GetClientName(superman, SpName, sizeof(SpName));
			
			PrintHintTextToAll("Superman is now: %s.", SpName);		
		
			if(GetConVarInt(g_Cvar_SupermanSpawnEffect) == 1)
			{
				CreateSpawnEffect(superman);
			}
		}
	}
}

public Event_DodStatsWeaponAttack(Handle:event,const String:name[],bool:dontBroadcast)
{		
	new time;
	if (GetMapTimeLeft(time) && time > 0)
	{
		new startTime = 120;
		if (time - startTime < 0 )
		{
			new weaponid = GetEventInt(event, "weapon");	
	
			new client;
			client = GetClientOfUserId(GetEventInt(event, "attacker"));
		
			if(client != superman)
			{
				if(weaponid == 1 || weaponid == 2)
				{
					decl Float:fPos[3], Float:fAng[3], Float:fVel[3];
					GetClientEyePosition(client, fPos);

					new entity = CreateEntityByName("prop_physics_override");
					DispatchKeyValue(entity,"model", ROCK_MDL);
					DispatchKeyValue(entity, "solid", "6");
					DispatchSpawn(entity); 
					AcceptEntityInput(entity, "TurnOn", entity, entity, 0);
					AcceptEntityInput(entity, "EnableCollision");
					SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
					SetVariantString(ADD_OUTPUT);
					AcceptEntityInput(entity, "AddOutput");
					/* calc & set spawn position, angle, velocity & spin */
					GetClientEyeAngles(client, fAng);
					GetAngleVectors(fAng, fVel, NULL_VECTOR, NULL_VECTOR);
					ScaleVector(fVel, g_fVelocity);
					SetEntPropVector(entity, Prop_Data, "m_vecAngVelocity", g_fSpin);
					SetEntPropFloat(entity, Prop_Send, "m_flElasticity", 0.2);
					/* add to lethal knife array then teleport... */
					//PushArrayCell(g_hLethalArray, entity);
					TeleportEntity(entity, fPos, fAng, fVel);
					DispatchKeyValue(entity, "StartDisabled", "false");
			
					new iEntity = CreateEntityByName("light_dynamic");
					DispatchKeyValue(iEntity, "inner_cone", "0");
					DispatchKeyValue(iEntity, "cone", "80");
					DispatchKeyValue(iEntity, "brightness", "0");
					DispatchKeyValueFloat(iEntity, "spotlight_radius", 240.0);
					DispatchKeyValueFloat(iEntity, "distance", 250.0);
					DispatchKeyValue(iEntity, "_light", "0 255 80 50");
					DispatchKeyValue(iEntity, "pitch", "-90");
					DispatchKeyValue(iEntity, "style", "5");
					DispatchSpawn(iEntity);
					TeleportEntity(iEntity, fPos, fAng, fVel);
			
					decl String:strName[32];
					Format(strName, sizeof(strName), "target%i", entity);
					DispatchKeyValue(entity, "targetname", strName);
			
					DispatchKeyValue(iEntity, "parentname", strName);
					SetVariantString("!activator");
					AcceptEntityInput(iEntity, "SetParent", entity, iEntity, 0);
					AcceptEntityInput(iEntity, "SetParentAttachmentMaintainOffset", entity, iEntity, 0);
					AcceptEntityInput(iEntity, "TurnOn");

					TE_SetupBeamFollow(entity, g_TrailSuperman, 0, 1.5, 10.7, 10.7, 5, ROCK_COLOR);
					TE_SendToAll();

					TraceHitPlayer(client);
					CreateTimer(1.0, RemoveEntity, entity);
				}
			}
		}
	}
}

public Action:TraceHitPlayer(any:client)
{
	new Float:vAngles[3], Float:vOrigin[3], Float:AnglesVec[3], Float:EndPoint[3], Float:pos[3];

	new Float:Distance = 1500.0;
	GetClientEyeAngles(client,vAngles);
	GetClientEyePosition(client,vOrigin);
	GetAngleVectors(vAngles, AnglesVec, NULL_VECTOR, NULL_VECTOR);
	
	EndPoint[0] = vOrigin[0] + (AnglesVec[0]*Distance);
	EndPoint[1] = vOrigin[1] + (AnglesVec[1]*Distance);
	EndPoint[2] = vOrigin[2] + (AnglesVec[2]*Distance);
	
	new Handle:trace = TR_TraceRayFilterEx(vOrigin, EndPoint, MASK_SHOT, RayType_EndPoint, TraceEntityFilterPlayer2, client);

	if (TR_DidHit(trace))
	{
		new TargetHit = TR_GetEntityIndex(trace);
		
		if ((TargetHit > 0) && (TargetHit <= GetMaxClients()))
		{
			new String:name[64];
			GetClientName(TargetHit, name, sizeof(name));
			
			if (TargetHit == superman)
			{		
				GetEntityAbsOrigin2(TargetHit,EndPoint);
				
				new Float:damage=GetConVarFloat(bonusround_damage);
				new Float:radius=GetConVarFloat(bonusround_radius);
				new Float:pushforce=GetConVarFloat(bonusround_pushforce);
		
				new pointHurt = CreateEntityByName("point_hurt");   
 	
				DispatchKeyValueFloat(pointHurt, "Damage", damage);        
				DispatchKeyValueFloat(pointHurt, "DamageRadius", radius);     
				DispatchKeyValue(pointHurt, "DamageDelay", "0.0");   
				DispatchSpawn(pointHurt);
				TeleportEntity(pointHurt, EndPoint, NULL_VECTOR, NULL_VECTOR);  
				AcceptEntityInput(pointHurt, "Hurt", -1);    
				CreateTimer(0.1, DeletePointHurt, pointHurt); 
	
		
				new push = CreateEntityByName("point_push");         
				DispatchKeyValueFloat (push, "magnitude", pushforce);                     
				DispatchKeyValueFloat (push, "radius", radius*1.0);                     
				SetVariantString("spawnflags 24");                     
				AcceptEntityInput(push, "AddOutput");
				DispatchSpawn(push);   
				TeleportEntity(push, EndPoint, NULL_VECTOR, NULL_VECTOR);  
				AcceptEntityInput(push, "Enable", -1, -1);
				CreateTimer(0.5, DeletePushForce, push);
			}
		}
	}

	TR_GetEndPosition(pos, trace);
	//draw your beam
	
	CloseHandle(trace);
}

stock Shake(Target, Float:flAmplitude, Float:flDuration)
{
    new Handle:hBf=StartMessageOne("Shake", Target);
    if(hBf!=INVALID_HANDLE)
    
    BfWriteByte(hBf,  0);
    BfWriteFloat(hBf, flAmplitude);
    BfWriteFloat(hBf, 1.0);
    BfWriteFloat(hBf, flDuration);
    EndMessage();
}

stock ShakeSuperman(TargetHit, Float:flAmplitude, Float:flDuration)
{
    new Handle:hBf=StartMessageOne("Shake", TargetHit);
    if(hBf!=INVALID_HANDLE)
    
    BfWriteByte(hBf,  0);
    BfWriteFloat(hBf, flAmplitude);
    BfWriteFloat(hBf, 1.0);
    BfWriteFloat(hBf, flDuration);
    EndMessage();
}

GetEntityAbsOrigin2(TargetHit,Float:EndPoint[3]) 
{
	decl Float:mins[3], Float:maxs[3];
	
	GetEntPropVector(TargetHit,Prop_Send,"m_vecOrigin",EndPoint);
	GetEntPropVector(TargetHit,Prop_Send,"m_vecMins",mins);
	GetEntPropVector(TargetHit,Prop_Send,"m_vecMaxs",maxs);
	
	EndPoint[0] += (mins[0] + maxs[0]) * 0.5;
	EndPoint[1] += (mins[1] + maxs[1]) * 0.5;
	EndPoint[2] += (mins[2] + maxs[2]) * 0.5;
	
	ShakeSuperman(TargetHit, AMP_SHAKE, DUR_SHAKE);
}

GetEntityAbsOrigin(Target,Float:EndPoint[3]) 
{
	decl Float:mins[3], Float:maxs[3];
	
	GetEntPropVector(Target,Prop_Send,"m_vecOrigin",EndPoint);
	GetEntPropVector(Target,Prop_Send,"m_vecMins",mins);
	GetEntPropVector(Target,Prop_Send,"m_vecMaxs",maxs);
	
	EndPoint[0] += (mins[0] + maxs[0]) * 0.5;
	EndPoint[1] += (mins[1] + maxs[1]) * 0.5;
	EndPoint[2] += (mins[2] + maxs[2]) * 0.5;
	
	IgniteEntity(Target,3.0);
	
	Shake(Target, AMP_SHAKE, DUR_SHAKE);

}

public Action:DeletePushForce(Handle:timer, any:ent)
{
	 if (IsValidEntity(ent))
	 {
		 decl String:classname[64];
		 GetEdictClassname(ent, classname, sizeof(classname));
		 if (StrEqual(classname, "point_push", false))
				{
 					AcceptEntityInput(ent, "Disable");
					AcceptEntityInput(ent, "Kill"); 
					RemoveEdict(ent);
				}
	 }
}
public Action:DeletePointHurt(Handle:timer, any:ent)
{
	 if (IsValidEntity(ent))
	 {
		 decl String:classname[64];
		 GetEdictClassname(ent, classname, sizeof(classname));
		 if (StrEqual(classname, "point_hurt", false))
				{
					AcceptEntityInput(ent, "Kill"); 
					RemoveEdict(ent);
				}
		 }

}

public Action:RemoveEntity(Handle:timer, any:entity)
{
	if (IsValidEntity(entity))
	{
		AcceptEntityInput(entity, "kill");
		RemoveEdict(entity);
	}
}
		
public Action:CreateBeam(any:client)
{
	for( new i = 1; i <= MaxClients; i++ )
	{	
		if(IsValidEntity(i) && superman == i)
		{
			new Float:Life;
			Life = GetConVarFloat( g_CvarLife );
			new Float:Width;
			Width = GetConVarFloat( g_CvarWidth );
	
			new Float:vAngles[3], Float:vOrigin[3], Float:AnglesVec[3], Float:EndPoint[3], Float:pos[3];

			new Float:Distance = 2000.0;
			GetClientEyeAngles(i,vAngles);
			GetClientEyePosition(i,vOrigin);
			GetAngleVectors(vAngles, AnglesVec, NULL_VECTOR, NULL_VECTOR);
	
			EndPoint[0] = vOrigin[0] + (AnglesVec[0]*Distance);
			EndPoint[1] = vOrigin[1] + (AnglesVec[1]*Distance);
			EndPoint[2] = vOrigin[2] + (AnglesVec[2]*Distance);
	
			new Handle:trace = TR_TraceRayFilterEx(vOrigin, EndPoint, MASK_SHOT, RayType_EndPoint, TraceEntityFilterPlayer, i);

			if (TR_DidHit(trace))
			{
				TR_GetEndPosition(pos, trace);
				vOrigin[0] -= 0;
				vOrigin[1] -= 2;
				vOrigin[2] -= 0;	
				//draw your beam
		
				TE_SetupBeamPoints(vOrigin,EndPoint, g_BeamSprite, 0, 0, 0, Life, Width, Width, 1, 0.0, redColor, 0);
				TE_SendToAll();		
		
				new Target = TR_GetEntityIndex(trace);
		
				if ((Target > 0) && (Target <= GetMaxClients()))
				{
					new String:name[64];
					GetClientName(Target, name, sizeof(name));
			
					GetEntityAbsOrigin(Target,EndPoint);
				}
			}
			CloseHandle(trace);
		}
	}
}

public Action:CreateBeam2(any:client)
{
	for( new i = 1; i <= MaxClients; i++ )
	{
		if(IsValidEntity(i) && superman == i)
		{
			new Float:Life;
			Life = GetConVarFloat( g_CvarLife );
			new Float:Width;
			Width = GetConVarFloat( g_CvarWidth );
	
			new Float:vAngles[3], Float:vOrigin[3], Float:AnglesVec[3], Float:EndPoint[3], Float:pos[3];

			new Float:Distance = 2000.0;
			GetClientEyeAngles(i,vAngles);
			GetClientEyePosition(i,vOrigin);
			GetAngleVectors(vAngles, AnglesVec, NULL_VECTOR, NULL_VECTOR);
	
			EndPoint[0] = vOrigin[0] + (AnglesVec[0]*Distance);
			EndPoint[1] = vOrigin[1] + (AnglesVec[1]*Distance);
			EndPoint[2] = vOrigin[2] + (AnglesVec[2]*Distance);
	
			new Handle:trace = TR_TraceRayFilterEx(vOrigin, EndPoint, MASK_SHOT, RayType_EndPoint, TraceEntityFilterPlayer, i);

			if (TR_DidHit(trace))
			{
				TR_GetEndPosition(pos, trace);
				vOrigin[0] -= 0;
				vOrigin[1] += 2;
				vOrigin[2] -= 0;	
				//draw your beam
		
				TE_SetupBeamPoints(vOrigin,EndPoint, g_BeamSprite, 0, 0, 0, Life, Width, Width, 1, 0.0, redColor, 0);
				TE_SendToAll();		
		
				new Target = TR_GetEntityIndex(trace);
		
				if ((Target > 0) && (Target <= GetMaxClients()))
				{
					new String:name[64];
					GetClientName(Target, name, sizeof(name));
			
					GetEntityAbsOrigin(Target,EndPoint);
				}
			}
			CloseHandle(trace);
		}
	}	
}

public bool:TraceEntityFilterPlayer(entity, mask, any:data)
{
    return data != entity;
}

public bool:TraceEntityFilterPlayer2(entity, mask, any:data)
{
    return data != entity;
}

public OnGameFrame()
{
	for( new i = 1; i <= MaxClients; i++ )
	{
		if(IsClientInGame(i) && IsClientConnected(i) && IsPlayerAlive(i) && superman == i)
		{
			new buttons = GetEntProp(i, Prop_Data, "m_nButtons", buttons);
			if ((buttons & IN_ATTACK))
			{
				CreateBeam(i);
				CreateBeam2(i);
			}
			elig = isEligible(i);

			if (!Eligible[i] && elig)
			{
				Notify(i);
			}
			Eligible[i] = elig;

			if (elig)
			{	
			if(buttons & IN_JUMP)
			{		
			if (Flying[i])
			KeepFlying(i);
			else	
			StartFlying(i);
			}
			else
			{
			if (Flying[i])
			StopFlying(i);
			}	
			}
			else
			{
			if (Flying[i])
			StopFlying(i);
			}
		}
	}
}

//Flight Section
bool:isEligible(client)
{

	if (!IsClientConnected(client)) return false;
	if (!IsClientInGame(client)) return false;
	
	return true;
}

public Action:StartFlying(client)
{
	Flying[client]=true;
	SetMoveType(client, MOVETYPE_FLYGRAVITY, MOVECOLLIDE_FLY_BOUNCE);
	AddVelocity(client, GetConVarFloat(FlySpeed));
		//return Plugin_Continue;
}

public Action:KeepFlying(client)
{
	AddVelocity(client, GetConVarFloat(FlySpeed));
	//return Plugin_Continue;
}

public Action:StopFlying(client)
{
	Flying[client]=false;
	SetMoveType(client, MOVETYPE_WALK, MOVECOLLIDE_DEFAULT);
	//return Plugin_Continue;
}

AddVelocity(client, Float:speed)
{
	new Float:maxSpeed = GetConVarFloat(MaxSpeed);
	new Float:vecVelocity[3];
	GetEntDataVector(client, PropVelocity, vecVelocity);
	if ((vecVelocity[2]+speed) > maxSpeed)
		vecVelocity[2] = maxSpeed;
	else
		vecVelocity[2] += speed;
	TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, vecVelocity);
}

SetMoveType(client, movetype, movecollide)
{
	SetEntData(client, PropMoveType, movetype);
	SetEntData(client, PropMoveCollide, movecollide);
}

public Notify(client)
{
	CreateTimer(1.5, NotifyClient, client);
}

public Action:NotifyClient(Handle:timer, any:client)
{
	if (isEligible(client))
		PrintToChat(client, "Hold the Jump Button to fly!!!");
}
